## xburst-tools 201007

=== target-stage1/Makefile ===
#
# Authors: Wolfgang Spraul <wolfgang@sharism.cc>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version
# 3 of the License, or (at your option) any later version.
#

ifeq ($(CROSS_COMPILE),)
$(error CROSS_COMPILE variable not set, should point to .../mipsel-openwrt-linux-)
endif

INCPATH = -I. -I../target-common/
CFLAGS	= -O2 -fno-unit-at-a-time -fno-zero-initialized-in-bss -mips32 -fno-pic \
	  -mno-abicalls $(INCPATH)
LDFLAGS	= -nostdlib -EL -T target.ld 
VPATH   = ../target-common

OBJS	= head.o stage1.o serial.o board-jz4740.o board-jz4760.o

all: stage1.bin

stage1.bin: stage1.elf
	$(CROSS_COMPILE)objcopy -O binary $< $@+
	$(CROSS_COMPILE)objdump -D $< > stage1.dump
	$(CROSS_COMPILE)objdump -h $< > stage1.map
	$(CROSS_COMPILE)nm -n $< > System.map
	chmod -x $@+
	mv -f $@+ $@

stage1.elf: $(OBJS)
	$(CROSS_COMPILE)ld $(LDFLAGS) $(OBJS) -o $@
.c.o:
	$(CROSS_COMPILE)gcc $(CFLAGS) -c $< -o $@
.S.o:
	$(CROSS_COMPILE)gcc $(CFLAGS) -c $< -o $@
clean:
	rm -f stage1.bin stage1.elf stage1.dump stage1.map
	rm -f $(OBJS)
	rm -f System.map

=== xburst_stage1/Makefile ===
#
# Authors: Xiangfu Liu <xiangfu@sharism.cc>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version
# 3 of the License, or (at your option) any later version.
#

INFLASH_SRC_PATH = ../src
XBURST_INCLUDE_PATH = ../xburst_include

ifeq ($(CROSS_COMPILE),)
$(error CROSS_COMPILE variable not set, should point to .../mipsel-openwrt-linux-)
endif

CFLAGS	:= -O2 -fno-unit-at-a-time -fno-zero-initialized-in-bss -mips32 -fno-pic \
	   -mno-abicalls -I$(INFLASH_SRC_PATH) -I$(XBURST_INCLUDE_PATH)
LDFLAGS	:= -nostdlib -EL -T target.ld 

OBJS	= head.o main.o common.o board-jz4740.o board-jz4760.o debug.o

all: xburst_stage1.bin

xburst_stage1.bin: xburst_stage1.elf
	$(CROSS_COMPILE)objcopy -O binary $< $@+
	$(CROSS_COMPILE)objdump -D $< > xburst_stage1.dump
	$(CROSS_COMPILE)objdump -h $< > xburst_stage1.map
	$(CROSS_COMPILE)nm -n $< > System.map
	chmod -x $@+
	mv -f $@+ $@

xburst_stage1.elf: $(OBJS)
	$(CROSS_COMPILE)ld $(LDFLAGS) $(OBJS) -o $@
.c.o:
	$(CROSS_COMPILE)gcc $(CFLAGS) -c $< -o $@
.S.o:
	$(CROSS_COMPILE)gcc $(CFLAGS) -c $< -o $@
clean:
	rm -f xburst_stage1.bin xburst_stage1.elf xburst_stage1.dump xburst_stage1.map
	rm -f $(OBJS)
	rm -f System.map

=== xburst_stage2/Makefile ===
#
# Authors: Lucifer at Ingenic Semiconductor Inc.
#          Xiangfu Liu <xiangfu@sharism.cc>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version
# 2 of the License, or (at your option) any later version.
#

INFLASH_SRC_PATH = ../src
XBURST_INCLUDE_PATH = ../xburst_include

ifeq ($(CROSS_COMPILE),)
$(error CROSS_COMPILE variable not set, should point to .../mipsel-openwrt-linux-)
endif

CC	= $(CROSS_COMPILE)gcc
AR	= $(CROSS_COMPILE)ar rcsv
LD	= $(CROSS_COMPILE)ld
OBJCOPY	= $(CROSS_COMPILE)objcopy
NM	= $(CROSS_COMPILE)nm
OBJDUMP	= $(CROSS_COMPILE)objdump

DEVICE ?=NANONOTE
DEBUG_CFLAGS = -g -Wa,-a=$(basename $@).lst
# Wolfgang saw data corruptions in stage2 when dealing with ECC data on random writes
# to NAND. Disabling the unit-at-a-time optimization reproducibly fixed the bug.
# The compiler may be optimizing in a way that conflicts with how the hardware ECC
# registers work. Since other register accesses might be affected too it seems the best
# is to disable this optimization right now.
CFLAGS	= -mips32 -O2 -fno-exceptions -fno-zero-initialized-in-bss \
	-ffunction-sections -fomit-frame-pointer -msoft-float -G 0 -fpie \
	-I$(XBURST_INCLUDE_PATH) -I$(INFLASH_SRC_PATH) -D$(DEVICE) 
LDFLAGS	= -nostdlib -T target.ld $(CFLAGS)

OBJS	= main.o udc.o cache.o serial.o boothandler.o nandflash_4740.o nandflash_4760.o

all: xburst_stage2.elf
	$(OBJCOPY) -O binary xburst_stage2.elf xburst_stage2.bin
	chmod -x xburst_stage2.bin
	$(OBJDUMP) -D xburst_stage2.elf > xburst_stage2.dump
	$(NM) xburst_stage2.elf | sort > xburst_stage2.sym
	$(OBJDUMP) -h xburst_stage2.elf > xburst_stage2.map

xburst_stage2.elf: head.o $(OBJS)
	$(CC) $(LDFLAGS) $^ -o $@

.c.o:
	$(CC) $(CFLAGS) -o $@ -c $<
.S.o:
	$(CC) $(CFLAGS) -o $@ -c $<

clean:
	rm -f $(addprefix xburst_stage2., bin dump elf map sym)
	rm -f head.o $(OBJS) $(OBJS:.o=.lst)

=== debian/changelog ===
xburst-tools (201007-1) unstable; urgency=low

  * Initial release, taken from commit 7b710f3 (Closes: #535429)

 -- Xiangfu Liu <xiangfu@sharism.cc>  Tue, 14 Sep 2010 22:34:15 +0800

=== debian/control ===
Source: xburst-tools
Section: misc
Priority: extra
Maintainer: Xiangfu Liu <xiangfu@sharism.cc>
Build-Depends: debhelper (>= 7.4.10),
	pkg-config, autoconf, automake,
	libusb-dev, libconfuse-dev
Build-Conflicts: automake1.4
Standards-Version: 3.9.1
Vcs-Git: git://projects.qi-hardware.com/xburst-tools.git
Vcs-Browser: http://projects.qi-hardware.com/index.php/p/xburst-tools/source/changes/master/
Homepage: http://projects.qi-hardware.com/index.php/p/xburst-tools/

Package: xburst-tools
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: tools for Ingenic XBurst CPU USB boot and NAND flash access
 xburst-tools contains tools for Ingenic XBurst CPU device booting.
 It can flash bootloader, kernel, rootfs to Ingenic XBurst CPU
 device NAND, and also has test functions for Ingenic XBurst CPU 
 devices.

=== debian/rules ===
#!/usr/bin/make -f
# This file is in the public domain.
# You may freely use, modify, distribute, and relicense it.

build clean install binary-arch binary-indep binary:
	+dh --parallel $(opt_no_act) $@

override_dh_auto_clean:
	test -e debian/xburst_stage1.bin || { \
		echo >&2 see debian/README.source; \
		exit 1; \
	}
	dh_auto_clean
	sh debian/clean.sh

override_dh_auto_configure: configure
	dh_auto_configure -- $(opt_optimize) $(opt_quiet) \
		--disable-firmware  LDFLAGS=-Wl,-z,defs

override_dh_auto_install:
	dh_auto_install
	: install firmware from source package
	dh_install debian/xburst_stage1.bin usr/share/xburst-tools/
	dh_install debian/xburst_stage2.bin usr/share/xburst-tools/
	dh_install debian/stage1.bin usr/share/xburst-tools/

override_dh_installchangelogs:
	dh_installchangelogs debian/changelog.upstream

opt_optimize = CFLAGS="-g -O2"
opt_no_act =
opt_quiet =

ifneq (,$(filter noopt,$(DEB_BUILD_OPTIONS)))
    opt_optimize = CFLAGS="-g -O0"
endif

ifneq (,$(findstring n,$(MAKEFLAGS)))
    opt_no_act = --no-act
endif

ifneq (,$(filter quiet,$(DEB_BUILD_OPTIONS)))
    opt_quiet = --quiet
    MAKEFLAGS += --quiet
endif

configure: configure.ac
	AUTOMAKE="automake --foreign" autoreconf -is

firmware: configure
	./configure --enable-firmware
	$(MAKE) -C usbboot/src \
		../xburst_stage1/xburst_stage1.bin \
		../xburst_stage2/xburst_stage2.bin
	$(MAKE) -C xbboot/host-app \
		../target-stage1/stage1.bin

VERSION = 201007
debiandir_SQ = $(subst ','\'',$(dir $(lastword $(MAKEFILE_LIST))))
get-orig-source:
	VERSION='$(VERSION)' sh '$(debiandir_SQ)'get-orig-source.sh

## xburst-tools 201206

=== target-echokernel/Makefile ===
#
# Authors: Wolfgang Spraul <wolfgang@sharism.cc>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version
# 3 of the License, or (at your option) any later version.
#

ifeq ($(CROSS_COMPILE),)
$(error CROSS_COMPILE variable not set, should point to .../mipsel-openwrt-linux-)
endif

CC	= $(CROSS_COMPILE)gcc
AR	= $(CROSS_COMPILE)ar rcsv
LD	= $(CROSS_COMPILE)ld
OBJCOPY	= $(CROSS_COMPILE)objcopy
NM	= $(CROSS_COMPILE)nm
OBJDUMP	= $(CROSS_COMPILE)objdump

DEBUG_CFLAGS = -g -Wa,-a=$(basename $@).lst
# Wolfgang saw data corruptions in stage2 when dealing with ECC data on random writes
# to NAND. Disabling the unit-at-a-time optimization reproducibly fixed the bug.
# The compiler may be optimizing in a way that conflicts with how the hardware ECC
# registers work. Since other register accesses might be affected too it seems the best
# is to disable this optimization right now.
CFLAGS	= -mips32 -O2 -fno-exceptions -fno-unit-at-a-time -fno-zero-initialized-in-bss \
	-ffunction-sections -fomit-frame-pointer -msoft-float -G 0 $(DEBUG_CFLAGS) -fPIC
LDFLAGS	= -nostdlib -T target.ld $(CFLAGS)
LIBS	= -lstdc++ -lc -lm -lgcc
VPATH   = ../target-common

OBJS	= echo-kernel.o serial.o

all: echo-kernel.elf
	$(OBJCOPY) -O binary echo-kernel.elf echo-kernel.bin
	$(OBJDUMP) -D echo-kernel.elf > echo-kernel.dump
	$(NM) echo-kernel.elf | sort > echo-kernel.sym
	$(OBJDUMP) -h echo-kernel.elf > echo-kernel.map

echo-kernel.elf: head.o $(OBJS)
	$(CC) $(LDFLAGS) $^ -o $@

.c.o:
	$(CC) $(CFLAGS) -o $@ -c $<
.cpp.o:
	$(CC) $(CFLAGS) -fno-rtti -fvtable-gc -o $@ -c $<
.S.o:
	$(CC) $(CFLAGS) -o $@ -c $<

clean:
	rm -f $(addprefix echo-kernel., bin dump elf map sym)
	rm -f head.o head.lst $(OBJS) $(OBJS:.o=.lst)

=== target-stage1/Makefile ===
--- 
+++ 
@@ -8,7 +8,7 @@
 #
 
 ifeq ($(CROSS_COMPILE),)
-$(error CROSS_COMPILE variable not set, should point to .../mipsel-openwrt-linux-)
+$(warning CROSS_COMPILE variable not set, should point to .../mipsel-openwrt-linux-)
 endif
 
 INCPATH = -I. -I../target-common/

=== xburst_stage1/Makefile ===
--- 
+++ 
@@ -11,7 +11,7 @@
 XBURST_INCLUDE_PATH = ../xburst_include
 
 ifeq ($(CROSS_COMPILE),)
-$(error CROSS_COMPILE variable not set, should point to .../mipsel-openwrt-linux-)
+$(warning CROSS_COMPILE variable not set, should point to .../mipsel-openwrt-linux-)
 endif
 
 CFLAGS	:= -O2 -fno-unit-at-a-time -fno-zero-initialized-in-bss -mips32 -fno-pic \

=== xburst_stage2/Makefile ===
--- 
+++ 
@@ -8,11 +8,10 @@
 # 2 of the License, or (at your option) any later version.
 #
 
-INFLASH_SRC_PATH = ../src
-XBURST_INCLUDE_PATH = ../xburst_include
+XBURST_INCLUDE_PATH = -I../xburst_include -I../src
 
 ifeq ($(CROSS_COMPILE),)
-$(error CROSS_COMPILE variable not set, should point to .../mipsel-openwrt-linux-)
+$(warning CROSS_COMPILE variable not set, should point to .../mipsel-openwrt-linux-)
 endif
 
 CC	= $(CROSS_COMPILE)gcc
@@ -31,7 +30,7 @@
 # is to disable this optimization right now.
 CFLAGS	= -mips32 -O2 -fno-exceptions -fno-zero-initialized-in-bss \
 	-ffunction-sections -fomit-frame-pointer -msoft-float -G 0 -fpie \
-	-I$(XBURST_INCLUDE_PATH) -I$(INFLASH_SRC_PATH) -D$(DEVICE) 
+	$(XBURST_INCLUDE_PATH) -D$(DEVICE) 
 LDFLAGS	= -nostdlib -T target.ld $(CFLAGS)
 
 OBJS	= main.o udc.o cache.o serial.o boothandler.o nandflash_4740.o nandflash_4760.o

=== debian/changelog ===
xburst-tools (201206-1build1) yakkety; urgency=medium

  * No-change rebuild against libconfuse1

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sat, 02 Jul 2016 00:10:13 +0000

xburst-tools (201206-1) unstable; urgency=low

  * Fix BIG-ENDIAN system error, taken from commit bf5b9f6

 -- Xiangfu Liu <xiangfu@sharism.cc>  Thu, 21 Jun 2012 18:33:04 +0800

xburst-tools (201105-1) unstable; urgency=low

  * Add new tool name `jzboot`, taken from commit 1d7a2f3
  * Add new command `reset` to usbboot

 -- Xiangfu Liu <xiangfu@sharism.cc>  Thu, 03 Mar 2011 14:43:59 +0800

xburst-tools (201012-1) unstable; urgency=low

  * Fix the nerase always erase good blocks, taken from commit fedb6d8

 -- Xiangfu Liu <xiangfu@sharism.cc>  Fri, 24 Dec 2010 13:24:30 +0800

=== debian/control ===
Source: xburst-tools
Section: misc
Priority: extra
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Xiangfu Liu <xiangfu@sharism.cc>
Build-Depends: debhelper (>= 9),
	pkg-config, autoconf, automake,
	libusb-dev, libconfuse-dev, libusb-1.0-0-dev,
	libreadline-dev
Build-Conflicts: automake1.4
Standards-Version: 3.9.4
Vcs-Git: git://projects.qi-hardware.com/xburst-tools.git
Vcs-Browser: http://projects.qi-hardware.com/p/xburst-tools/source/changes/master/
Homepage: http://projects.qi-hardware.com/p/xburst-tools/

Package: xburst-tools
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: tools for Ingenic XBurst CPU USB boot and NAND flash access
 xburst-tools contains tools for Ingenic XBurst CPU device booting.
 It can flash bootloader, kernel, rootfs to Ingenic XBurst CPU
 device NAND, and also has test functions for Ingenic XBurst CPU 
 devices.
